# Integrate iDEAL using the Orders API (/api/orders-v2/ideal)



Render payment buttons and process payments with the Orders API.

## Know before you code [#know-before-you-code]

* Request approval to enable iDEAL by visiting these sandbox and live links:
  * Sandbox: [https://www.sandbox.paypal.com/bizsignup/entry?product=ideal\&capabilities=IDEAL\&country.x=\<merchant's country>](https://www.sandbox.paypal.com/bizsignup/entry?product=ideal\&capabilities=IDEAL\&country.x=)
  * Live: [https://www.paypal.com/bizsignup/entry?product=ideal\&capabilities=IDEAL\&country.x=\<merchant's country>](https://www.paypal.com/bizsignup/entry?product=ideal\&capabilities=IDEAL\&country.x=\<merchant's,country>)
* Partners: Be sure to onboard your merchants upfront, [before they accept payments](/platforms/seller-onboarding/before-payment/). Onboarding after making payments, specifically Progressive Onboarding, isn't supported for alternative payment methods.

> **Note:** **Note:** The integration steps for implementing alternative payment methods are similar. If you've integrated another alternative payment method before, you can likely reuse that code with adjustments for this payment method.

* Make sure you're [subscribed to the following webhook events](/payment-methods/webhooks):
  * `PAYMENT.CAPTURE.COMPLETED` - Listen for this webhook to get notified about a successful order capture.
  * `PAYMENT.CAPTURE.DENIED` - This webhook tells you when an order capture fails.
* Make sure your preference for receiving payments in your PayPal business or merchant account is set to accept and convert to the currency in your account. In your profile, select **Account Settings** > **Payment preferences** > **Block payments** and click **Update** to mark this preference.

* Request approval to enable iDEAL by visiting these sandbox and live links. Replace `MERCHANT-COUNTRY` in the URL with the 2-character [country code](/api/codes/country-region) for the merchant's country of operation:
  * Sandbox: `https://www.sandbox.paypal.com/bizsignup/entry?product=ideal&capabilities=IDEAL&country.x=MERCHANT-COUNTRY`
  * Live: `https://www.paypal.com/bizsignup/entry?product=ideal&capabilities=IDEAL&country.x=MERCHANT-COUNTRY`

* When processing iDEAL payments, you don't need to capture payment for the order.

## 1. Offer iDEAL on the checkout page [#1-offer-ideal-on-the-checkout-page]

You'll need to create the user interface to offer banks through iDEAL and collect the buyer's information, then you'll use the API calls described in the remainder of this topic to:

* Create the order with buyer's `full_name,` `country_code` and iDEAL as the payment source.
* Redirect the buyer to iDEAL.
* Refer to [Payment method icons](/platforms/checkout/apm/reference/method-icons/) for icons you can use and download locations.

## 2. Create an order [#2-create-an-order]

Use the buyer information you captured from your user interface to create an order with iDEAL as the payment source.

API endpoint used in Sample request: [Create order](/api/orders/v2/orders-create)

#### Sample request

```text lineNumbers
curl -v -X POST 'https://api-m.sandbox.paypal.com/v2/checkout/orders' \
-H "PayPal-Request-Id: PAYPAL-REQUEST-ID" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer ACCESS-TOKEN" \
-d '{
    "intent": "CAPTURE",
    "purchase_units": [
        {
            "reference_id": "d9f80740-38f0-11e8-b467-0ed5f89f718b",
            "amount": {
                "currency_code": "EUR",
                "value": "1.00"
              }
          }
    ],
    "payment_source": {
        "ideal": {
            "country_code": "NL",
            "name": "Firstname Lastname"
        }
    }
}'
```

#### Sample response

```text lineNumbers
{
  "id": "ORDER-ID",
  "status": "PAYER_ACTION_REQUIRED",
  "payment_source": {
    "ideal": {
      "name": "Firstname Lastname",
      "country_code": "NL"
    }
  },
  "links": [
    {
      "href": "https://api-m.sandbox.paypal.com/v2/checkout/orders/ORDER-ID",
      "rel": "self",
      "method": "GET"
    },
    {
      "href": "https://www.sandbox.paypal.com/payment/ideal?token=ORDER-ID",
      "rel": "payer-action",
      "method": "GET"
    }
  ]
}
```

### Modify the code [#modify-the-code]

After you copy the code in the sample request, modify the following:

* `ACCESS-TOKEN` - Your [access token](/api/rest/authentication).
* `PayPal-Request-Id` - Replace the sample ID with a unique ID you generate. This ID helps prevent duplicate authorizations in the event that the API call is disrupted. See also: [API idempotency](/api/rest/reference/idempotency)
* `intent` - To use an alternative payment method, this parameter must be set to `CAPTURE` as it is in this sample code.
* `payment_source` - Specify `ideal` as the payment method and include the country code and account holder's full name.
* `purchase_units.amount` - Pass the amount of the order and the currency code.
* `processing_instruction` - Set this value to `ORDER_COMPLETE_ON_PAYMENT_APPROVAL` as it is in this sample code.
* `application_context` - Specify the preferred language for returned errors, the URL the buyer is returned to after approving the purchase with their selected payment method, and the URL the buyer is returned to after canceling an approval with their selected payment method. While `return_url` and `cancel_url` are optional fields, this integration requires you specify them to handle the handoff from the payment method back to your site. You can use the `cancel_url` to redirect buyers when an error occurs while they're on the payment method's site, so make sure your cancel URL works for that situation as well as an actual cancellation by the buyer.

> **Note:** **Note:** Change or add other parameters in the [Create order request body](/api/orders/v2/orders-create) to create an order that reflects the actual order details.

### Step result [#step-result]

A successful request results in the following:

* A return status code of HTTP `200 OK`.
* A JSON response body that contains the order ID. You'll use the order ID and `payer-action` HATEOAS URL in the next step. See also: [HATEOAS links](/api/rest/responses/#hateoas-links).

### Merchant onboarding payment error [#merchant-onboarding-payment-error]

Partners need to onboard merchants upfront [before they accept payments](/platforms/seller-onboarding/before-payment/). iDEAL doesn't support onboarding after making payments, specifically Progressive Onboarding. See the [Onboard a merchant](/ideal#onboard-a-merchant-for-ideal-payments) section for more details.

When you submit an order with `ideal` as the `payment_source`, and the merchant isn't onboarded, you get the following error message:

`The 'API caller' and/or 'payee' is not set up to be able to process the selected payment source. If you have already completed the required steps, please allow 2 business days for PayPal to complete the setup. If you continue to receive this error, please contact your Account Manager or check status at https://www.paypal.com/businessmanage/account/payments.`

### Unsuccessful confirm order request [#unsuccessful-confirm-order-request]

This code sample shows an unsuccessful attempt to confirm an order without a properly onboarded merchant.

API endpoint used in the sample request: [Create order](/api/orders/v2/orders-confirm)

#### Sample request

```text lineNumbers
curl -v -X POST 'https://api-m.sandbox.paypal.com/v2/checkout/orders/ORDER-ID/confirm-payment-source' \
-H "PayPal-Request-Id: PAYPAL-REQUEST-ID" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer ACCESS-TOKEN" \
-d '{
    "payment_source": {
        "ideal": {
            "country_code": "NL",
            "name": "Firstname Lastname",
            "experience_context": {
                "return_url": "https://example.com/return",
                "cancel_url": "https://example.com/cancel"
            }
        }
    }
}'
```

#### Sample response

```text lineNumbers
{
  "name": "UNPROCESSABLE_ENTITY",
  "details": [
    {
      "issue": "NOT_ENABLED_FOR_PAYMENT_SOURCE",
      "description": "The 'API caller' and/or 'payee' is not setup to be able to process the selected payment source. If you have already completed the required steps, please allow 2 business days for PayPal to complete the setup. If you continue to receive this error, please contact your Account Manager or check status at https://www.paypal.com/businessmanage/account/payments.",
      "fields": [
        {
          "field": "/payment_source/ideal"
        }
      ]
    }
  ],
  "message": "The requested action could not be performed, semantically incorrect, or failed business validation.",
  "debug_id": "90957fca61718",
  "links": [
    {
      "href": "https://developer.paypal.com/api/orders/v2/error-messages",
      "rel": "information_link",
      "method": "GET"
    }
  ]
}
```

### Step result [#step-result-1]

This unsuccessful single-shot create order request results in the following:

* A return status code of HTTP `422 Unprocessable Entity`.
* A JSON response body that passes `NOT_ENABLED_FOR_PAYMENT_SOURCE`, a description of the error, and a message that `details.fields.field` has an incorrect value.

### Unsuccessful single-shot create order request [#unsuccessful-single-shot-create-order-request]

This code sample shows an unsuccessful attempt to create a new order and capture the payment without a properly onboarded merchant.

API endpoint used in the sample request: [Create order](/api/orders/v2/orders-create)

#### Sample request

```text lineNumbers
curl -v -X POST 'https://api-m.sandbox.paypal.com/v2/checkout/orders' \
-H "PayPal-Request-Id: PAYPAL-REQUEST-ID" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer ACCESS-TOKEN" \
-d '{
        "intent": "CAPTURE",
        "payment_source": {
            "ideal": {
                "country_code": "NL",
                "name": "Firstname Lastname",
                "experience_context": {
                    "return_url": "https://example.com/return",
                    "cancel_url": "https://example.com/cancel"
                }
            }
        },
        "processing_instruction": "ORDER_COMPLETE_ON_PAYMENT_APPROVAL",
        "purchase_units": [
            {
                "reference_id": "d9f80740-38f0-11e8-b467-0ed5f89f718b",
                "amount": {
                    "currency_code": "EUR",
                    "value": "100"
                }
            }
        ]
    }
}'
```

#### Sample response

```text lineNumbers
{
  "name": "UNPROCESSABLE_ENTITY",
  "details": [
    {
      "issue": "NOT_ENABLED_FOR_PAYMENT_SOURCE",
      "description": "The 'API caller' and/or 'payee' is not setup to be able to process the selected payment source. If you have already completed the required steps, please allow 2 business days for PayPal to complete the setup. If you continue to receive this error, please contact your Account Manager or check status at https://www.paypal.com/businessmanage/account/payments.",
      "fields": [
        {
          "field": "/payment_source/ideal"
        }
      ]
    }
  ],
  "message": "The requested action could not be performed, semantically incorrect, or failed business validation.",
  "debug_id": "90957fca61718",
  "links": [
    {
      "href": "https://developer.paypal.com/api/orders/v2/error-messages",
      "rel": "information_link",
      "method": "GET"
    }
  ]
}
```

### Step result [#step-result-2]

This unsuccessful single-shot create order request results in the following:

* A return status code of HTTP `422 Unprocessable Entity`.
* A JSON response body that passes `NOT_ENABLED_FOR_PAYMENT_SOURCE`, a description of the error, and a message that `details.fields.field` has an incorrect value.

## 3. Redirect buyer for purchase approval [#3-redirect-buyer-for-purchase-approval]

In your user interface, attach the `payer-action` redirect URL returned in the Create Order response to the iDEAL payment button. This sends the buyer to their bank to approve the purchase. Once the buyer approves the purchase, the payment is automatically captured.

In the sample, the redirect URL is: `"https://www.sandbox.paypal.com/payment/ideal?token=5KP92830L1747245S"`.

### Step result [#step-result-3]

After successfully completing the bank approval:

* The buyer is redirected to the `return_url` mentioned in the Create Order request.
* The `PAYMENT.CAPTURE.COMPLETED` webhook event is triggered, which indicates that payment capture was successful.

After unsuccessful bank approval:

* The buyer is redirected to the `cancel_url` mentioned in the Create Order request.

## 4. Listen to webhooks for payment status [#4-listen-to-webhooks-for-payment-status]

Listen to the following webhooks to get the result of order capture:

* The `PAYMENT.CAPTURE.COMPLETED` webhook event indicates a successful order capture.
* The `PAYMENT.CAPTURE.DENIED` webhook events indicate a failed order capture.
* Optional: Use [Show order details](/api/orders/v2/orders-get) endpoint to determine the status of an order.
  * The `up` HATEOAS link indicates the order associated with this capture.

See [Subscribe to checkout webhooks](/payment-methods/webhooks) for more information.

Here are some additional resources as you create webhook handler code:

* [Webhook Management API](/api/webhooks/v1) - Manage webhooks, list event notifications, and more.
* Webhook event
  * [Checkout webhook events](/api/rest/webhooks/event-names/#checkout-buyer-approval) - Checkout buyer approval-related webhooks.
  * [Order webhook events](/api/rest/webhooks/event-names/) - Other order-related webhooks.
* [Show order details endpoint](/api/orders/v2/orders-get) - Determine the status of an order.

### Sample Webhook Payloads [#sample-webhook-payloads]

#### Sample PAYMENT.CAPTURE.COMPLETED

```text lineNumbers
{
  "id": "WH-2B342482FC0449155-12X09416XP387753C",
  "event_version": "1.0",
  "zts": 1481046241,
  "create_time": "2022-04-08T10:37:05Z",
  "resource_type": "capture",
  "resource_version": "2.0",
  "event_type": "PAYMENT.CAPTURE.COMPLETED",
  "summary": "Payment completed for EUR 1.00 EUR",
  "resource": {
    "amount": {
      "value": "1.00",
      "currency_code": "EUR"
    },
    "create_time": "2022-04-08T10:37:05Z",
    "update_time": "2022-04-08T10:37:05Z",
    "final_capture": true,
    "seller_receivable_breakdown": {
      "paypal_fee": {
        "value": "0.20",
        "currency_code": "EUR"
      },
      "gross_amount": {
        "value": "1.00",
        "currency_code": "EUR"
      },
      "net_amount": {
        "value": "0.80",
        "currency_code": "EUR"
      }
    },
    "links": [
      {
        "method": "GET",
        "rel": "self",
        "href": "https://api-m.sandbox.paypal.com/v2/payments/captures/8SS60826HT082593F"
      },
      {
        "method": "POST",
        "rel": "refund",
        "href": "https://api-m.sandbox.paypal.com/v2/payments/captures/8SS60826HT082593F/refund"
      },
      {
        "method": "GET",
        "rel": "up",
        "href": "https://api-m.sandbox.paypal.com/v2/checkout/orders/5KP92830L1747245S"
      }
    ],
    "id": "8SS60826HT082593F",
    "status": "COMPLETED"
  },
  "links": [
    {
      "href": "https://api-m.sandbox.paypal.com/v1/notifications/webhooks-events/WH-2B342482FC0449155-12X09416XP387753C",
      "rel": "self",
      "method": "GET"
    },
    {
      "href": "https://api-m.sandbox.paypal.com/v1/notifications/webhooks-events/WH-2B342482FC0449155-12X09416XP387753C/resend",
      "rel": "resend",
      "method": "POST"
    }
  ]
}
```

#### Sample PAYMENT.CAPTURE.DENIED

```text lineNumbers
{
  "id": "WH-2B342482FC0449155-12X09416XP387753C",
  "event_version": "1.0",
  "create_time": "2022-04-08T10:37:05Z",
  "resource_type": "capture",
  "resource_version": "2.0",
  "event_type": "PAYMENT.CAPTURE.DENIED",
  "summary": "Payment denied for EUR 1.00 EUR",
  "resource": {
    "amount": {
      "value": "1.00",
      "currency_code": "EUR"
    },
    "supplementary_data": {
      "related_ids": {
        "order_id": "5KP92830L1747245S"
      }
    },
    "create_time": "2022-04-08T10:37:05Z",
    "update_time": "2022-04-08T10:37:05Z",
    "final_capture": true,
    "seller_receivable_breakdown": {
      "paypal_fee": {
        "value": "0.20",
        "currency_code": "EUR"
      },
      "gross_amount": {
        "value": "1.00",
        "currency_code": "EUR"
      },
      "net_amount": {
        "value": "0.80",
        "currency_code": "EUR"
      }
    },
    "links": [
      {
        "method": "GET",
        "rel": "self",
        "href": "https://api-m.sandbox.paypal.com/v2/payments/captures/8SS60826HT082593F"
      },
      {
        "method": "POST",
        "rel": "refund",
        "href": "https://api-m.sandbox.paypal.com/v2/payments/captures/8SS60826HT082593F/refund"
      },
      {
        "method": "GET",
        "rel": "up",
        "href": "https://api-m.sandbox.paypal.com/v2/checkout/orders/5KP92830L1747245S"
      }
    ],
    "id": "8SS60826HT082593F",
    "status": "DECLINED"
  },
  "links": [
    {
      "href": "https://api-m.sandbox.paypal.com/v1/notifications/webhooks-events/WH-2B342482FC0449155-12X09416XP387753C",
      "rel": "self",
      "method": "GET"
    },
    {
      "href": "https://api-m.sandbox.paypal.com/v1/notifications/webhooks-events/WH-2B342482FC0449155-12X09416XP387753C/resend",
      "rel": "resend",
      "method": "POST"
    }
  ]
}
```

#### Sample CHECKOUT.ORDER.DECLINED

```text lineNumbers
{
  "id": "WH-1SW574877T049922Y-2X2706431J788111J",
  "event_version": "1.0",
  "create_time": "2022-04-08T10:37:05Z",
  "resource_type": "checkout-order",
  "resource_version": "2.0",
  "event_type": "CHECKOUT.ORDER.DECLINED",
  "summary": "An order has been declined",
  "resource": {
    "create_time": "2022-04-08T10:37:05Z",
    "purchase_units": [
      {
        "reference_id": "d9f80740-38f0-11e8-b467-0ed5f89f718b",
        "amount": {
          "currency_code": "EUR",
          "value": "1.00"
        },
        "most_recent_errors": [
          {
            "issue": "PAYMENT_SOURCE_CANNOT_BE_USED",
            "description": "The provided payment source cannot be used to pay for the order. Please try again with a different payment source by creating a new order."
          }
        ]
      }
    ],
    "links": [
      {
        "href": "https://api-m.sandbox.paypal.com/v2/checkout/orders/5KP92830L1747245S",
        "rel": "self",
        "method": "GET"
      }
    ],
    "id": "5KP92830L1747245S",
    "payment_source": {
      "ideal":  {
        "name": "Firstname Lastname",
        "country_code": "NL"
      }
    },
    "intent": "CAPTURE",
    "status": "PAYER_ACTION_REQUIRED"
  },
  "links": [
    {
      "href": "https://api-m.sandbox.paypal.com/v1/notifications/webhooks-events/WH-1SW574877T049922Y-2X2706431J788111J",
      "rel": "self",
      "method": "GET"
    },
    {
      "href": "https://api-m.sandbox.paypal.com/v1/notifications/webhooks-events/WH-1SW574877T049922Y-2X2706431J788111J/resend",
      "rel": "resend",
      "method": "POST"
    }
  ]
}
```

> **Note:** **Note:**
>
> * order ID from [Step 2](#2-create-an-order) should match `resource.supplementary_data.related_ids.order_id` parameter in the webhook payload.
>
> * When an order is declined, the CHECKOUT.ORDER.DECLINED webhook passes the error code and message in the most\_recent\_error parameter of the purchase\_unit object.

Alternatively, if your app misses the webhook needed to capture the order, you can get the order capture result by sending a `GET` call to the [Show order details](/api/orders/v2/orders-get) endpoint of the Orders v2 API.

> **Note:** **Important:** Exercise caution when polling for order capture results using the [Show order details](/api/orders/v2/orders-get) endpoint. PayPal enforces rate limits on API requests.

#### Sample request

```text lineNumbers
curl -v -X GET https://api-m.sandbox.paypal.com/v2/checkout/orders/5KP92830L1747245S \
 -H "Content-Type: application/json" \
 -H "Authorization: Bearer <Access-Token>"
```

#### Sample response

```text lineNumbers
{
  "id": "5KP92830L1747245S",
  "intent": "CAPTURE",
  "status": "COMPLETED",
  "payment_source": {
    "ideal": {
      "name": "Firstname Lastname",
      "country_code": "NL"
    }
  },
  "processing_instruction": "ORDER_COMPLETE_ON_PAYMENT_APPROVAL",
  "purchase_units": [
    {
      "reference_id": "default",
      "amount": {
        "currency_code": "EUR",
        "value": "1.00"
      },
      "payments": {
        "captures": [
          {
            "id": "8SS60826HT082593F",
            "status": "COMPLETED",
            "amount": {
              "currency_code": "EUR",
              "value": "1.00"
            },
            "final_capture": true,
            "seller_receivable_breakdown": {
              "gross_amount": {
                "currency_code": "EUR",
                "value": "1.00"
              },
              "paypal_fee": {
                "currency_code": "EUR",
                "value": "0.20"
              },
              "net_amount": {
                "currency_code": "EUR",
                "value": "0.80"
              }
            },
            "links": [
              {
                "href": "https://api-m.sandbox.paypal.com/v2/payments/captures/8SS60826HT082593F",
                "rel": "self",
                "method": "GET"
              },
              {
                "href": "https://api-m.sandbox.paypal.com/v2/payments/captures/8SS60826HT082593F/refund",
                "rel": "refund",
                "method": "POST"
              },
              {
                "href": "https://api-m.sandbox.paypal.com/v2/checkout/orders/5KP92830L1747245S",
                "rel": "up",
                "method": "GET"
              }
            ],
            "create_time": "2022-04-08T10:37:05Z",
            "update_time": "2022-04-04T10:37:05Z"
          }
        ]
      }
    }
  ],
  "create_time": "2022-04-08T10:37:05Z",
  "update_time": "2022-04-08T10:37:05Z",
  "links": [
    {
      "href": "https://api-m.sandbox.paypal.com/v2/checkout/orders/5KP92830L1747245S",
      "rel": "self",
      "method": "GET"
    }
  ]
}
```

### Step result [#step-result-4]

A successful request returns the HTTP `200 OK` status code with a JSON response body that returns a `COMPLETED` status.

A successfully captured order has the following:

* The order status as `COMPLETED`, which means the order was captured successfully.
* A capture with `COMPLETED` status is present in the response parameter `purchase_units[0].payments.captures[0]`.
* The `up` HATEOAS link indicates the order associated with this capture.

## 5. Notify buyer of payment success [#5-notify-buyer-of-payment-success]

After a successful payment, notify the buyer of a successful transaction. You can do this by sending a confirmation email.

## Next steps [#next-steps]

> **Info:** Test integration
>
> Test the integration in the PayPal sandbox environment.

> **Info:** Go live
>
> Take your application live in the PayPal production environment once testing is successful.
